Name: imapsync
Summary: Tool to migrate email between IMAP servers
Version: 1.476
Release: 1%{?dist}
License: WTFPL
Group: Applications/Internet

URL: http://fedorahosted.org/imapsync
Source0: https://fedorahosted.org/released/%{name}/%{name}-%{version}.tgz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch: noarch
BuildRequires: perl(Test::Simple) perl(Digest::MD5)
BuildRequires: perl(Mail::IMAPClient) >= 3.25
Requires: perl(Test::Simple) perl(Authen::NTLM)
Requires: perl(Digest::MD5) perl(Digest::HMAC_MD5)
Requires: perl(Term::ReadKey) perl(IO::Socket::SSL)
Requires: perl(File::Spec) perl(File::Path)
Requires: perl(Mail::IMAPClient) >= 3.25


%description
imapsync is a tool for facilitating incremental recursive IMAP
transfers from one mailbox to another. It is useful for mailbox migration,
and reduces the amount of data transferred by only copying messages that
are not present on both servers. Read, unread, and deleted flags are preserved,
and the process can be stopped and resumed. The original messages can
optionally be deleted after a successful transfer.

%prep
%setup -q

cat << \EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* |\
  sed -e '/perl(--prefix2)/d'
EOF

%define __perl_requires %{_builddir}/%{name}-%{version}/%{name}-req
chmod +x %{__perl_requires}

%build

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install DESTDIR="$RPM_BUILD_ROOT"
iconv -f iso-8859-1 -t utf-8 -o ChangeLog.utf8 ChangeLog && %{__mv} ChangeLog.utf8 ChangeLog
iconv -f iso-8859-1 -t utf-8 -o TODO.utf8 TODO && %{__mv} TODO.utf8 TODO

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc ChangeLog CREDITS INSTALL TODO README FAQ
%{_bindir}/imapsync
%attr(644, root, root) %{_mandir}/man1/imapsync.1*

%ChangeLog
* Tue Dec 13 2011 Nick Bebout <nb@fedoraproject.org> - 1.476-1
- Upgrade to 1.476

* Mon Nov 21 2011 Nick Bebout <nb@fedoraproject.org> - 1.468-1
- Upgrade to 1.468

* Thu Sep 8 2011 Nick Bebout <nb@fedoraproject.org> - 1.456-1
- Upgrade to 1.456

* Mon Jul 11 2011 Nick Bebout <nb@fedoraproject.org> - 1.452-1
- Added the --search option allowing to select messages with the powerful IMAP SEARCH command.
- Added IO::Socket::INET version info.
- Bugfix. Fixed ps call to work with Solaris 10. Thanks to Daniel Rohde.
- Kerio 7.2.0P1 success.
- MDaemon 12.0.3 success.
- Bugfix. Date reference to select messages with --maxdate --mindate is the beginning of imapsync run now.
- Added PERMANENTFLAGS output with --debugflags

* Tue May 31 2011 Nick Bebout <nb@fedoraproject.org> - 1.446-1
- Bugfix. Try to handle Markus bug in foldersizes() when select_msgs() returns a list of undef.
- Check if uidexpunge is supported at the beginning of execution, not when needed.
- Set --uidexpunge2 if --delete2 or --expunge2 if uidexpunge not supported.
- Changed all warn() calls (STDERR) to print calls (STDOUT)
- good_date() "24 Aug 77" -> "24-Aug-1977"
- Patched tests_good_date() and good_date() with Dax Kelson patches.
- Started code to deal with epoch of messages.
- Handle better folder creation, not a failure when folder "already exists" during its creation.
- Replaced default setting. Now --delete2 sets --uidexpunge2 instead of --expunge2 (unless --nouidexpunge2 is set)
- Added epoch() routine to prepare the safe bidirectional sync (maybe...)
- Adapted the usage output multiline character to Unix or Win, \ or ^
- Bugfix. Avoid a "no number" warning when size is null.
- Added "Date" in the default --useheader list. ("Message-Id", "Message-ID", "Date")
- Bugfix. Bad header beginning with a blank character.

* Tue May 24 2011 Nick Bebout <nb@fedoraproject.org> - 1.434-1
- Bugfix. Made --usecache work with --maxage or --maxsize or --min*
- Improved the way imapsync deals with headers:
-  - Stopped getting first 2KB of message. Not a good idea.
-  - If $imap2->parse_headers() fails then take the whole header (instead of body).
-  - Default is like --useheader Message-Id --useheader Message-ID
-  - Use header Message-Id and header Date as sig md5 when taking the whole header.
- Better output in debug mode.
- Options --usecache and --maxsize --minsize can safely be used if --delete is there
- Added tests of mkpath very long path > 300 char. Win32 fails on them.
- Bugfix. Added special case for Inbox vs INBOX bug creation ("Couldn't create folder [Inbox] from [INBOX]: 143 NO INBOX already exists!")
- Adapted regression tests for good_date() when no zone is given.
- Bugfix. intarnal date needs zone data. Default to  +0000.
- Bugfix. Starttls() only for 2.2.9
- Fix. Removed a debug print always printed.
- Bugfix. Changed the way imapsync knows whether a folder exists or not. Exchange might be happy and stop deconnecting for this reason.
- Added a warning and die if --usecache and one of  --maxsize--minsize --maxage --minage is used.
- Bugfix. Reconnections are well done in tls mode now.
- Zimbra 5.0.24_GA_3356.RHEL4 [host1]
- Exchange 2010 SP1 RU2 [host2]
- Added --debugsleep to have to play will kill and reconnections.

* Mon May 16 2011 Nick Bebout <nb@fedoraproject.org> - 1.422-1
- Added --debugLIST to track messages list uid or number only.
- Bugfix: a lack of variable initialisation caused to fetch no existing messages.
-  The APPEND error then the FETCH 0 byte error may be fixed now.
- relogin1 before each folder select.
- --splitX are set into sub login_imap() now.
- Added --relogin1 option (--relogin1 5) to force a reconnection when FETCH message fails on host1.
- Added --debugcontent to avoid debugging content (can be big) with --debug option.
- Added --debugflags to permit flag debugging only.
- Added --flagsCase to correct flag case that are not RFC compliant \SEEN -> \Seen (on by default).
- Added output to track 0 byte messages during the fetch on host1.
- Bugfix. --proxyauth2 was setting proxyauth1!
-  Thanks to Denis BREAN!
- MDaemon 12
- Exchange 6.5 host1
- Bugfix. Modified create_folder() to avoid Inbox -> INBOX problem ("already exists").
- Bugfix. --maxsize --minsize now work with --useuid
- Bugfix. flag sync of already transfered messages now take care of --maxsize --minsize options.
- --delete2 implies --expunge2 now unless --noexpunge2 is given.
- exit if --delete and --delete2 are given together.
- Same behavior for --expunge or --expunge1.
- Added 0 length message tracking when fetching host1.

* Sun Apr 24 2011 Nick Bebout <nb@fedoraproject.org> - 1.411-1
- Bugfix for "Folders in host2 not in host1" list when
- folders are given by --folder option or equivalent.
- The old list listed too many folders with --folder INBOX for example.
- Updated success list.
- Added --takebody option.
- Added  Gimap (Gmail imap) success.
- Added IMail 11.03 [host1] success
- Made --delete2 works with --uselib or --usecache
- No longer --useuid with --fast
- Debug output with permanentflags.
- Added isync url.
- Sleep 2 seconds after foldersizes calls.

* Sat Apr 2 2011 Nick Bebout <nb@fedoraproject.org> - 1.404-3
- Add dependency on Authen::NTLM

* Wed Mar 16 2011 Nick Bebout <nb@fedoraproject.org> - 1.404-2
- Remove dependency on Date::Manip and Mail::Box

* Mon Feb 21 2011 Nick Bebout <nb@fedoraproject.org> - 1.404-1
- Upgrade to 1.404

* Wed Feb 16 2011 Nick Bebout <nb@fedoraproject.org> - 1.398-1
- Upgrade to 1.398

* Sun Dec 5 2010 Nick Bebout <nb@fedoraproject.org> - 1.366-1
- Upgrade to 1.366

* Tue Aug 10 2010 Nick Bebout <nb@fedoraproject.org> - 1.340-1
- Upgrade to 1.340

* Thu Jul 22 2010 Nick Bebout <nb@fedoraproject.org> - 1.337-1
- Upgrade to 1.337

* Wed Jun 16 2010 Nick Bebout <nb@fedoraproject.org> - 1.315-1
- Upgrade to 1.315

* Fri May 28 2010 Nick Bebout <nb@fedoraproject.org> - 1.311-1
- Upgrade to 1.311
- License is now WTFPL

* Tue Aug 4 2009 Nick Bebout <nb@fedoraproject.org> - 1.286-1
- Upgrade to 1.286

* Fri Aug  8 2008 Lubomir Rintel <lkundrak@v3.sk> - 1.255-3
- Attempt to patch around too new Mail::IMAPClient

* Wed Aug  6 2008 Marek Mahut <mmahut@fedoraproject.org> - 1.255-2
- Upstream release

* Tue May 27 2008 Marek Mahut <mmahut@fedoraproject.org> - 1.252-2
- Upstream release
- Dependency fix (BZ#447800)

* Thu Apr 10 2008 Marek Mahut <mmahut@fedoraproject.org> - 1.249-1
- Initial build.
